/*********************************************************************
 * Clase general para Actores que no son Jugadores Principales. 
 * Programación Multimedia y Juegos
 * Autor: David Vallejo Fernández    david.vallejo@tegnix.com
 * Autor: Carlos González Morcillo   carlos.gonzalez@tegnix.com
 *
 * You can redistribute and/or modify this file under the terms of the
 * GNU General Public License ad published by the Free Software
 * Foundation, either version 3 of the License, or (at your option)
 * and later version. See <http://www.gnu.org/licenses/>.
 *
 * This file is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.  
 *********************************************************************/

package com.juego.bee.graphics.sprites;

import aze.display.TileClip;
import aze.display.TileLayer;

class NonPlayer extends TileClip {
  var _w:Int;           // Ancho de la pantalla
  var _h:Int;           // Alto de la pantalla
  var _root:TileLayer;  // Capa principal de dibujado

  // Constructor ====================================================
  public function new(id:String, layer:TileLayer, w:Int, h:Int) {
    super(layer, id); _w = w; _h = h; _root = layer;
  }

  // Metodo para eliminar objetos hijo (si los tuviera)
  public function removeChildObjects():Void {

  }

  // Funcion general para determinar si el objeto esta en pantalla
  function isInside():Bool {
    return (x > -width / 2);
  }

  // Este método será sobreescrito por las clases hijas. 
  // Devuelve true si tiene que seguir actualizándose y false
  //   en caso contrario (ha finalizado y debe ser eliminado).
  public function update(w:Int, h:Int, eTime:Int):Bool { 
    return (true); 
  }

}